Index: Tst/Short/sba_s.res.gz.uu
===================================================================
--- Tst/Short/sba_s.res.gz.uu	(revision e702ac277be2db4c7ac783bdaefeeaabc0920d4e)
+++ Tst/Short/sba_s.res.gz.uu	(revision 88bb8861e1718d85807ce45f043eba5c778545e1)
@@ -1,33 +1,33 @@
 begin 644 sba_s.res.gz
-M'XL(""-LEU(``W-B85]S+G)E<P"56%MOVS84?L^O((P`DV-;Y5TD7`?(L@$-
-M5FQ`TCT,15<XCE,[OL)2L-1#_OLH42:/;LSJ!YGBN?"<C^<[HG3WZ9>;WQ%"
-MY!*]>X?.;Q[.S^[**1HC-V9Q+D[OIU_3.$LS-!JA]6[[#67S-$O1X^Z0RYPV
-M+[2?TWF*#K/OL_5RAN8OT\U^;28>#[L-NKF[N[K^22NTG^[G!V<GP(HR1A]O
-M?D8]LUJ\7M[WQDZ27"(S^76Y7691?WR6_Z/+RS*X[?R?.,VFF=-6E]ZG+GSV
-M]KOU]ZI/@KT6(3':'W8SM)IFZ?-ANHV6VPP=^TYN</G7W1A@S"_7V*().GJ/
-MHA`<E@:D6R-A%&,VC%XB',?1MM_O#Q_V7CFQ7A[FTS5:&NUR::/H=72A4_S2
-MK/![/]_.%D:[]]O5I[L_;Z]&O8&50#M*"KOYRWYWR*);(&!0L`2",O1Y]GS8
-M1L4B0&A"?74W`%RJ:[`M:K@Q#'!CI`,WQL*X#1<5Y)BH(;?8;7;?(H_?$,3.
-MDA^"<-`;??`EPG0'CIQTX,A9`$<N`(Y<>AQY4N)HB5.O/JX`BEQWH"A(",41
-MJ=6?8#44[=JPC(3HQN[ZK^N/-]>MU2>2#M2$[D!-D@!JD@'4)/>H25%%K5Y\
-M4@+89-(!F]1OP58KOX2TEI^##U9?PGX$P6KQ):(#QB3I@#'1`1@5`3`JZF%4
-MK(1Q/MO9RMOV/6Z*^_ZL9%Q">#0)&&R\<Q5W87BLEIW&N::[HR>/F^'3<.6U
-M>.PA]K/%^GDG1\!AL?3>K.K"(;A8Q#RAHLT$CS?O)\<1'6\&`Y\7P=3N3&ZX
-MOWB)-GUS.?:]"V[E*R/'?E;:V=SUTV0S(..GW+GYJSI7IVTOW*,!>HE6^0)/
-MM54(/BFN!@,_6\;VZB8X"!:-4&16[H\=C(2482T_&\&77,G[4M[4`T2+=9U_
-M:K?AL]G2+\@HFAA-X1>ACF"XE)^P]I!0V<":U+"F*JZ!L?$^63441F.@Z2-F
-MO`RQFAZ3KCP)<Z@WR?;K]1^>:<<<O9,5+]9OD(EP"N9OP;PG!.%%[JU\(WG3
-M=EEQ[?A&!`9\6]0)1_(V[L:L@W#$MN8.PE4;%K']V-WI5LH1VX-KE".2-2E'
-MI&A2SO;7(.7*3ENGW,7".2E;:XUTIR;Z!ND2\3])ER1MI"N;I]\S15I(=['X
-MFP'B*=9)/"7:B*>22K4K'22>68TZ4TV:Y-/L3?)I$2"?KH:C-22?VQ>*21OY
-M*&:N5"D.G!4:Y*L\Z"A.6AE(L6YE("6>(=2>Q5L92`DX;E'BCULT/WKG!%AY
-M57.HS5]HHM7$;._J_42.\^+H.[GV1PEJFV<MR=/);>77MUTUW1N][+$>'`5/
-MN,>Q"ZWLIL:A>;6)ED,RQ,!&U86^CU';1[T00TO;5:$06A:AK)9K0_SAX_!V
-M6(3JQ;([W07,U_;?CGQMFVWDRVD@7\X#^7(9R)>K0+X"!_,5M"5?]UX(\A4\
-MD*^0K?F*QA:"J"4.Y"L;6P@M>2!?*8/Y2A7(M[+!"0XDG-#6A)/&'H*PDT:U
-M@["3QAX"2]6H=F"I:#!AQ5L2+@Z_(%=[UNW(U1YW&[GJQOZ!B'6CTD'$NK%_
-MT+)1Z=!2A7)EN*U7V8.'3Y;A0*=BN+53,1SH5`P'.A4C@4[%2*!3,1+L5"P_
-M!K^>E>]5S`U&'\Y.;_K,C\QL_EQB]FKN2G7N!L".^U%IQ^W5VPDW`';"CTH[
-M8:_>3KH!L)-^5-I)>S5WIV03]T!C^2$__SR6?P1[3B.#V/G9?T/[#(CE$P``
+M'XL("`5'GE(``W-B85]S+G)E<P"5F%MOVS84Q]_S*0@CP.185DD>DA+A.D"6
+M#6BP8@.2[F$HNL)QG-KQ%9:"I1[RW4==3%*R=++FP:%X+J1^.O\CVG>??KGY
+MG1#"+LF[=^3\YN'\[*Z:XA&Q8XAR<WH_^9I&69J1X9"LMIMO))NE64H>M_O<
+M9KU%X?V<SE*RGWZ?KA93,GN9K'<K,_&XWZ[)S=W=U?5/.B&[R6ZVMW'26U%%
+MY./-SZ1G5HM6B_O>R%KB2V(FORXVBRSHC\[R_^3RLMK<9O9/E&:3S'HGERZG
+M+G+V=MO5]WI.1IT78Q'9[;=3LIQDZ?-^L@D6FXP<^M9NN/QK+PP8\Y=[;,B8
+M'%Q&61CV"P/IUEB`4PIA\!+0*`HV_7X_?-@YY[C,\C";K,C">%=+&T?GHPN?
+MXB_-BKSWL\UT;KQ[OUU]NOOS]FK8&Y06/XZS(F[VLMONL^#6,X!O6'B&:NNS
+M['F_"8I%/*/9ZJN]\.!RW<`V;W`#ZG$#UL$-`.<6SFOD0#;(S;?K[;?`\0N]
+MO4/\0P@'O>$'5R*@.S@*UL%1`,)12(^C4(ZCB"N.I7":U2<2CZ+0'10EPR@.
+M6:/^)#0HEFO[921E-[OKOZX_WERW5I^,.ZA)W4%-,82:`H^:$HZ:DG5JS>)3
+MRL.FX@YL2K^%K5%^,6LM/XO/K[X8?H1@O?ABV8$QCCLPQAK!F#`/8\(=Q@0J
+MC+/IMJR\3=]Q2X3KSXF**H0'<P.&C4N>1%T,#_6RTS3WM%?\F'$=/H5+YR4B
+MA]C-%NOGG9QX"8NE=V95NQU&BT7,&RI8C^EH_7Y\&/+1>C!P]\4H+Y],'KB[
+M>`G6??-QZ+L4HK0OC9VZ657.YJF?QNL!&SWER<V_>O+D^-B+]&1`7H)EOL!3
+M8Q5&CX[+P<#-5GM[M1/"VRP9DL"LW!]9C(Q5VUI\-H8ON9/+E;A0!X@7Z]K\
+MO'P,G\TC_4*,H]FC*?QBJT-_NUP<63LD7)VP9@W6/(D:,-8N)]2W`CSR/-V.
+M051;K-\>*%N>#"SU4[']>OV'4]HAIW>,$L7Z)V)B@GOSM]Z\$P03Q;VWZHWE
+M3=O>E=!6;TQ23V_SIN!8WL;M&#H$Q\K6W"&X>L-B93^V5[I5<JSLP0W),06G
+MDF-*GDJN[*^HY*I.VY3<Q=PFJ5IK0W3')OJ&Z&+Y/T47QVVBJYJG>V8):Q'=
+MQ?QO\(270*?P$MDFO"2N57NB4>&9U;@-U>Q4?!K>%)^6B/AT?3M:^^*SSX53
+MUB8^3L&6*J?(6>%$?+47':=QJP(YU:T*Y,PIA)=G\58%<N8=MSASQRV>'[US
+M`2R=JSG4YE]H@N78/-[E^[$:Y<71MW;MCA*\;)Z-FSR>W)9N_;*KICOCESTV
+M-\>]-]SCR&ZMZJ8FH?EJ$RQ"'E(O)FD:71_C91]U1N9'EEW5-_J1HFZDM4C5
+M-/J1Q8:6BY5I&>%C>!L6-VG-`@$U]TD)C)1H)R4P4@(C)3%2$B,E,5(2(R5Q
+M4JJ-E/TNZI%2&"G53DIAI!1&*L9(Q1BI&",58Z1BG%2"D:H558*A2MI1)1BJ
+M!$.E,50:0Z4Q5!I#I5%40-M0%8=\1PDH0@EH*R6@""6@""5@""5@""5@""5@
+M""5@.*76;EX>S3Q,6"^']EX.6"\'K)<#ULL!Z^6`]7+`>CG@O1SR7OYZ5GUG
+M!3L8?C@[_HH";F1F\W<^E)_FJG(7=N#%"3>JXD3YZ>*D'7AQTHVJ.%E^NCAE
+I!UZ<<J,J3I6?YNIXL\P>%B!_-^4_/>8_,#ZG@2%V?O8?1I:\JD$5````
 `
 end
Index: Tst/Short/sba_s.stat
===================================================================
--- Tst/Short/sba_s.stat	(revision e702ac277be2db4c7ac783bdaefeeaabc0920d4e)
+++ Tst/Short/sba_s.stat	(revision 88bb8861e1718d85807ce45f043eba5c778545e1)
@@ -1,4 +1,4 @@
-1 >> tst_memory_0 :: 1385654086:3.1.3.sw, 64  1385654090:3.1.3.sw, 64  1385655331:3.1.3.sw, 64 bit:spielwiese:x86_64-Linux:schosch:34043056
-1 >> tst_memory_1 :: 1385654086:3.1.3.sw, 64  1385654090:3.1.3.sw, 64  1385655331:3.1.3.sw, 64 bit:spielwiese:x86_64-Linux:schosch:35934208
-1 >> tst_memory_2 :: 1385654086:3.1.3.sw, 64  1385654090:3.1.3.sw, 64  1385655331:3.1.3.sw, 64 bit:spielwiese:x86_64-Linux:schosch:36069376
-1 >> tst_timer_1 :: 1385654086:3.1.3.sw, 64  1385654090:3.1.3.sw, 64  1385655331:3.1.3.sw, 64 bit:spielwiese:x86_64-Linux:schosch:69
+1 >> tst_memory_0 :: 1385654086:3.1.3.sw, 64  1385654090:3.1.3.sw, 64  1385655331:3.1.3.sw, 64  1386104581:3.1.3.sw, 64 bit:spielwiese:x86_64-Linux:schosch:239564024
+1 >> tst_memory_1 :: 1385654086:3.1.3.sw, 64  1385654090:3.1.3.sw, 64  1385655331:3.1.3.sw, 64  1386104581:3.1.3.sw, 64 bit:spielwiese:x86_64-Linux:schosch:246226944
+1 >> tst_memory_2 :: 1385654086:3.1.3.sw, 64  1385654090:3.1.3.sw, 64  1385655331:3.1.3.sw, 64  1386104581:3.1.3.sw, 64 bit:spielwiese:x86_64-Linux:schosch:246305512
+1 >> tst_timer_1 :: 1385654086:3.1.3.sw, 64  1385654090:3.1.3.sw, 64  1385655331:3.1.3.sw, 64  1386104581:3.1.3.sw, 64 bit:spielwiese:x86_64-Linux:schosch:550
Index: Tst/Short/sba_s.tst
===================================================================
--- Tst/Short/sba_s.tst	(revision e702ac277be2db4c7ac783bdaefeeaabc0920d4e)
+++ Tst/Short/sba_s.tst	(revision 88bb8861e1718d85807ce45f043eba5c778545e1)
@@ -129,4 +129,6 @@
   sprintf(bench);
   ideal f; 
+  f = sba(i,2,0);
+  f = sba(i,2,1);
   f = sba(i,1,0);
   f = sba(i,1,1);
@@ -137,4 +139,6 @@
   sprintf(bench);
   ideal f; 
+  f = sba(i,2,0);
+  f = sba(i,2,1);
   f = sba(i,1,0);
   f = sba(i,1,1);
@@ -145,4 +149,6 @@
   sprintf(bench);
   ideal f; 
+  f = sba(i,2,0);
+  f = sba(i,2,1);
   f = sba(i,1,0);
   f = sba(i,1,1);
@@ -153,4 +159,6 @@
   sprintf(bench);
   ideal f; 
+  f = sba(i,2,0);
+  f = sba(i,2,1);
   f = sba(i,1,0);
   f = sba(i,1,1);
@@ -161,4 +169,6 @@
   sprintf(bench);
   ideal f; 
+  f = sba(i,2,0);
+  f = sba(i,2,1);
   f = sba(i,1,0);
   f = sba(i,1,1);
@@ -169,4 +179,6 @@
   sprintf(bench);
   ideal f; 
+  f = sba(i,2,0);
+  f = sba(i,2,1);
   f = sba(i,1,0);
   f = sba(i,1,1);
Index: kernel/kstd2.cc
===================================================================
--- kernel/kstd2.cc	(revision e702ac277be2db4c7ac783bdaefeeaabc0920d4e)
+++ kernel/kstd2.cc	(revision 88bb8861e1718d85807ce45f043eba5c778545e1)
@@ -55,9 +55,9 @@
 #define SBA_TAIL_RED                        1
 #define SBA_PRODUCT_CRITERION               0
-#define SBA_PRINT_ZERO_REDUCTIONS           1
-#define SBA_PRINT_REDUCTION_STEPS           1
-#define SBA_PRINT_OPERATIONS                1
-#define SBA_PRINT_SIZE_G                    1
-#define SBA_PRINT_SIZE_SYZ                  1
+#define SBA_PRINT_ZERO_REDUCTIONS           0
+#define SBA_PRINT_REDUCTION_STEPS           0
+#define SBA_PRINT_OPERATIONS                0
+#define SBA_PRINT_SIZE_G                    0
+#define SBA_PRINT_SIZE_SYZ                  0
 #define SBA_PRINT_PRODUCT_CRITERION         0
 