Index: doc/copyright.tex
===================================================================
--- doc/copyright.tex	(revision 91dbdf1c9526451dc3e3d3d1f0da9d02fe1072ae)
+++ doc/copyright.tex	(revision 91dbdf1c9526451dc3e3d3d1f0da9d02fe1072ae)
@@ -0,0 +1,158 @@
+@cindex factory
+@cindex GMP
+@cindex MP
+@cindex readline
+@cindex libfac
+
+@center @sc{Singular} version @value{VERSION}
+@center University of Kaiserslautern
+@center Department of Mathematics and Centre for Computer Algebra
+Authors: G.-M. Greuel, G. Pfister, H.
+@tex
+ Sch\"onemann
+@end tex
+@ifinfo
+ Schoenemann
+@end ifinfo
+
+Copyright @copyright{} 1986-98 ; All Rights reserved
+@sp 2
+                                @center NOTICE
+
+
+Permission to use, copy, modify, and distribute this software or parts
+thereof and its documentation or parts thereof for non-commercial
+purposes and without fee is hereby granted provided the following three
+conditions are satisfied:
+
+@enumerate
+@item
+The above copyright notice appears in all copies of the software
+and both the copyright notice and this permission notice
+appear in supporting documentation.
+
+@item
+The name of the program ("@sc{Singular}") is retained and the name of
+the program is displayed when it is run interactively.
+
+@item
+Portions of the software which are modified are marked and a notice of the
+modification is displayed when the program is run interactively.
+@end enumerate
+
+Neither the University of Kaiserslautern nor the Authors make any
+representations about the suitability of this software for any
+purpose.  This software is provided ``as is'' without express or
+implied warranty.
+
+If your intended use of @sc{Singular} is not covered by the license above,
+please contact us.  Notice that in the license above we have not
+granted permission to make copies of Singular to be sold, distributed
+on media which are sold, or distributed along with software which is
+sold. We have also not granted you permission to extract a portion
+of the source code of Singular and incorporate it into another program.
+
+If you use Singular or parts thereof in a project and/or publish
+results that were partly obtained using @sc{Singular}, we request that you
+cite @sc{Singular} and inform us about it.
+
+Please send any comments or bug reports to
+@code{singular@@mathematik.uni-kl.de}.
+
+The following parts of @sc{Singular} have their own copyright: the Gnu Multiple
+Precision Library (GMP), the Multi Protocol library (MP), the Readline library,
+the libfac library,  and the Factory library.
+Their copyrights and licences can be found in the accompanying files
+which are distributed along with these libraries.
+
+@section Availability
+The latest information about @sc{Singular} is always available from
+@code{http://www.mathematik.uni-kl.de/~zca/Singular}.
+The program @sc{Singular} and the above mentioned parts are available via
+anonymous ftp through the following addresses
+(log in as ftp with your email address as password):
+@table @asis
+@item GMP
+@copyright{} Free Software Foundation:
+@code{libgmp-2.0.2.tar.gz}
+@* @code{ftp.gnu.ai.mit.edu} or its mirrors
+@item readline
+@copyright{} Free Software Foundation:
+@code{libreadline-2.0.tar.gz}
+@* @code{ftp.gnu.ai.mit.edu} or its mirrors
+@item MP
+@copyright{} Gray/Kajler/Wang, Kent State University:
+@code{MP-1.1.2.tar.gz},
+@* @code{mcs.kent.edu:/pub/MP}
+@item factory
+@copyright{} Greuel/Stobbe, University of Kaiserslautern:
+@code{factory-1.3b.tar.gz}
+@* @code{www.mathematik.uni-kl.de:/pub/Math/Factory}
+(or, via a WWW browser from http://www.mathematik.uni-kl.de/ftp/pub/Math/Singular/Factory)
+@item libfac
+@copyright{}  Mesollen, University  of Saarbruecken:
+@code{libfac-0.3.0.tar.gz}
+@* contact michael@@math.uni-sb.de for details on libfac.
+@item @sc{Singular} binaries
+@code{www.mathematik.uni-kl.de:/pub/Math/Singular/bin}
+(or, via a WWW browser from http://www.mathematik.uni-kl.de/ftp/pub/Math/Singular/bin)
+@item @sc{Singular} sources
+@code{www.mathematik.uni-kl.de:/pub/Math/Singular/src}
+(or, via a WWW browser from http://www.mathematik.uni-kl.de/ftp/pub/Math/Singular/src)
+@end table
+
+@ifset singularmanual
+@section Acknowledgements
+
+The development of @sc{Singular} is directed and coordinated by
+Gert-Martin Greuel, Gerhard Pfister and Hans
+@tex
+ Sch\"onemann.
+@end tex
+@ifinfo
+ Schoenemann.
+@end ifinfo
+Contributions to different parts of @sc{Singular} have been made by
+Olaf Bachmann,
+Wolfram Decker,
+Hubert Grassmann,
+Bernd Martin,
+Wolfgang Neumann,
+@tex
+Thomas N\"u{\ss}ler,
+@end tex
+@ifinfo
+Thomas Nuessler,
+@end ifinfo
+Wilfried Pohl,
+Thomas Siebert,
+@tex
+R\"udiger Stobbe
+@end tex
+@ifinfo
+Ruediger Stobbe
+@end ifinfo
+and
+Tim Wichmann.
+
+We should like to acknowledge the financial support given by
+the Volkswagen-Stiftung,
+the Deutsche Forschungsgemeinschaft
+and the Stiftung
+@ifinfo
+fuer
+@end ifinfo
+@tex
+f\"ur
+@end tex
+ Innovation des Landes Rheinland-Pfalz
+to the
+@sc{Singular} project.
+
+@end ifset
+
+@c @iftex
+@c @sp 20
+@c @end iftex
+@c @*Opinions expressed are mine,  all mine,
+@c @*but they can become yours too for a small monthly fee.