Index: Makefile.in
===================================================================
--- Makefile.in	(revision 1f03735b40dfd822d0a1399857e5b395aea36c4f)
+++ Makefile.in	(revision 93a7f7b1c20c3c886dd4dff521c518039f3824e7)
@@ -334,14 +334,14 @@
 	@echo -e  '       -P /bin/rxvt -d "This starts an rxvt terminal."' >> /etc/postinstall/singular-icons.sh
 	@echo -e  '' >> /etc/postinstall/singular-icons.sh
-        @echo -e  '# XServer + xterm' >> /etc/postinstall/singular-icons.sh
-        @echo -e  'if test -f /bin/XWin.exe; then' >> /etc/postinstall/singular-icons.sh
-        @echo -e  'mkshortcut -A -a \047bash -l -c "/bin/startxwin.bat"\047 \' >> /etc/postinstall/singular-icons.sh
-        @echo -e  '       -i /bin/XWin.exe \' >> /etc/postinstall/singular-icons.sh
-        @echo -e  '       -P /usr/X11R6/bin/run.exe -n "Singular CAS\\Cygwin\\Start X-Server and an XTerm" \' >> /etc/postinstall/singular-icons.sh
-        @echo -e  '       -d "This starts the Cygwin X-Server and launches an XTerm."' >> /etc/postinstall/singular-icons.sh
-        @echo -e  'fi' >> /etc/postinstall/singular-icons.sh
-        @echo -e  '' >> /etc/postinstall/singular-icons.sh
+	@echo -e  '# XServer + xterm' >> /etc/postinstall/singular-icons.sh
+	@echo -e  'if test -f /bin/XWin.exe; then' >> /etc/postinstall/singular-icons.sh
+	@echo -e  'mkshortcut -A -a \047bash -l -c "/bin/startxwin.bat"\047 \' >> /etc/postinstall/singular-icons.sh
+	@echo -e  '       -i /bin/XWin.exe \' >> /etc/postinstall/singular-icons.sh
+	@echo -e  '       -P /usr/X11R6/bin/run.exe -n "Singular CAS\\Cygwin\\Start X-Server and an XTerm" \' >> /etc/postinstall/singular-icons.sh
+	@echo -e  '       -d "This starts the Cygwin X-Server and launches an XTerm."' >> /etc/postinstall/singular-icons.sh
+	@echo -e  'fi' >> /etc/postinstall/singular-icons.sh
+	@echo -e  '' >> /etc/postinstall/singular-icons.sh
 	@echo -e  '# Only XServer' >> /etc/postinstall/singular-icons.sh
-        @echo -e  'if test -f /bin/XWin.exe; then' >> /etc/postinstall/singular-icons.sh
+	@echo -e  'if test -f /bin/XWin.exe; then' >> /etc/postinstall/singular-icons.sh
 	@echo -e  'mkshortcut -A -a \047\047 \' >> /etc/postinstall/singular-icons.sh
 	@echo -e  '       -i /bin/XWin.exe \' >> /etc/postinstall/singular-icons.sh
@@ -363,5 +363,5 @@
 	@echo -e  '' >> /etc/postinstall/singular-icons.sh
 	@echo -e  '# Emacs + Singular' >> /etc/postinstall/singular-icons.sh
-        @echo -e  'if test -f /bin/XWin.exe; then' >> /etc/postinstall/singular-icons.sh
+	@echo -e  'if test -f /bin/XWin.exe; then' >> /etc/postinstall/singular-icons.sh
 	@echo -e  'mkshortcut -A -a \047bash -l -c "/bin/startxwin.bat && sleep 1 && ESingular"\047 \' >> /etc/postinstall/singular-icons.sh
 	@echo -e  '       -i ${CYGWIN_SINGULAR_BIN}/runESingular.exe -n "Singular CAS\\Singular (Emacs and X-Server)" \' >> /etc/postinstall/singular-icons.sh
@@ -382,5 +382,5 @@
 	@echo -e  '' >> /etc/postinstall/singular-icons.sh
 	@echo -e  '# Emacs + Singular' >> /etc/postinstall/singular-icons.sh
-        @echo -e  'if test -f /bin/XWin.exe; then' >> /etc/postinstall/singular-icons.sh
+	@echo -e  'if test -f /bin/XWin.exe; then' >> /etc/postinstall/singular-icons.sh
 	@echo -e  'mkshortcut -A -a \047bash -l -c "/bin/startxwin.bat && sleep 1 && ESingular"\047 \' >> /etc/postinstall/singular-icons.sh
 	@echo -e  '       -i ${CYGWIN_SINGULAR_BIN}/runESingular.exe -n "Singular CAS\\Singular (Emacs and X-Server)" \' >> /etc/postinstall/singular-icons.sh
@@ -461,6 +461,4 @@
 	cp ${CYGWIN_AUX_FILES}/SURF_COPYING ${CYGWIN_SINGULAR_BIN}/
 	cp ${CYGWIN_AUX_FILES}/Manual.chm ${CYGWIN_SINGULAR_DOC}/doc
-	cp ${CYGWIN_AUX_FILES}/startxserver.bat ${CYGWIN_SINGULAR_BIN}/
-	unix2dos ${CYGWIN_SINGULAR_BIN}/startxserver.bat
 ##	Download setup exe
 	export http_proxy=http://positron.mathematik.uni-kl.de:3128; \
@@ -515,6 +513,5 @@
 	tar cjf ${CYGWIN_REP_DIR}/release/Singular/singular-icons-${CYGWIN_PORT_VER}.tar.bz2  \
 	      /usr/share/doc/Cygwin/singular-icons-${CYGWIN_SING_VER}.README \
-	      ${CYGWIN_SINGULAR_BIN}/cygwin-setup.exe                \
-	      ${CYGWIN_SINGULAR_BIN}/startxserver.bat                \
+	      ${CYGWIN_SINGULAR_BIN}/cygwin-setup.exe                \              \
 	      /etc/postinstall/singular-icons.sh
 	cp singular-base-${CYGWIN_PORT_VER}-src.tar.bz2 ${CYGWIN_REP_DIR}/release/Singular/