Index: Tst/Short/factorizeQ_s.res.gz.uu
===================================================================
--- Tst/Short/factorizeQ_s.res.gz.uu	(revision 09f10ea22a97a54f71079faae7206def58b37826)
+++ Tst/Short/factorizeQ_s.res.gz.uu	(revision 107aac1a78fd9b689a33a864d23b7cfb1caa5bdf)
@@ -1,11 +1,21 @@
 begin 644 factorizeQ_s.res.gz
-M'XL("!]4&E```V9A8W1O<FEZ95%?<RYR97,`75++:L,P$+S[*X;0@]48)9*=
-M])%*A])+H!1">@M.2-/8"(P=+#FE+?WW2G:02B_2/F9G9U=:OSXM7P`PB>?E
-M(T9&&UJIM]$B6E\R7,(&=ZI6)B:+R-V0$L7^8)I6?1U7.TWKXP?59F]\42KA
-M[8SBU#8'F*,V0Y5&7"EM4"4X-=4G"N+!,XIO[\RI/7I$*<""I%L7+YH6L:H-
-ME,M!X4%`6SV6>\-R8B/CL>=E4U?BF1EW+AQM>=WC-RK?5AON;N(;L<S!?KS;
-MZRDA!(J`Z<54WN>VDZ_@+.R!VYZ3B6DILO3.!U.*5M4EVI68)G&7G$GR?@ID
-MF;QL"`+==9R>QXQL><C/)(9-BO`@<1$FX'/Y;^^)R[+(CGP?6>$[:P@V6#P7
-HW6"EN7"M(AOJ42QA"?><-W^&LM.[W^$>O],Q(XNKZ!<3F14Y4P(`````
+M'XL("""V2%```V9A8W1O<FEZ95%?<RYR97,`[5??;]HP$'[GKSA->TC(C_K.
+M9R=9ESQ,>ZDT3:JZMPJJP@I$0H!(Z+1-^]]G$^H`*7NHJE65*@2Q/W\^W]UG
+MY_#5M\\77P$`"_AR\0G>U54=S\O1N_/>U6Z$"C#@3;DH:\\_[]DG%`5,;L?U
+M<EW^NKN\J>+%W8^XJF]K-TD6X-H<PVJ]'$-]5]7-K`J\>5G5,`]AM9S_A(GO
+MR"J&WZZC8_.S94QSP-:EU.*3Y1J\<E%#:<>@A(\Y5,8?8_L:![Y!@L#916&G
+M.,M(M@O6[+2_Y5^7@^'\FNS3=PLA6]H?U]WZ,X4\ATG+V3HS=WTR*[D9A&T>
+MR*QY=E:O8V"9.5#&L"X74UA?YB+T-N&]'WY?M<:XV&4(<MCT/7D?H#^D=EP5
+MT&0R;P7Q)FT$I(NCO(=V%'LFY`\]X_B-:>38M&B0;YJ6'.1VJ9Z!MBP,,21G
+M,]D+*G5!<>K`["$HX[4G0KB=A3`RWVHF_!"\\8Q"&,_0`FA;%IVW44NQBWIE
+MIGNCV9#]OB$-.?`025+_=C:D_LC^&(M#BH[0B#C3PO1M3S:<X``+D%"GMLD/
+M)F0B=;]=BP)/H199JK0UW-`X0B$)LP2I!2DX($:89!))LUW,K#Z:-5,#J5)-
+MBM)#G+I\XZI$K20>!\H1)TIHC9T1$Y[$3(A4B+TTH$+C56.Y304'E#(R'^,V
+M!T2I,=&F228"E5"ZS11'FCD3;$AM]HQ%85;?8;[??XIJP2.J1?]+M>"$:M$)
+MU;K\YU(M.*%:=$*UX&55,PI)ZIZU/2Q`5(H.54,2SW36.$%.T\Y9XXPI2W3W
+MK!WQC0(B5<INJXYJ2C"KE+BK&F8J$[IQXN&LL>"$CE-ASIK&-$F2SL8V6YF%
+M8MY334I-F!RHIA*M$Y7R@6J<D1":=ZJU;TU\I!:`M]IC4*<8K/Y5#-ZVPZO;
+M#JY\OY7-5U<V&^WX2=J]%<^7+9X'_Y3-Q[UR]RY"TMPF[$W*7I0VE8?^^?O>
+)7QE2;8Y_#0``
 `
 end
Index: Tst/Short/factorizeQ_s.stat
===================================================================
--- Tst/Short/factorizeQ_s.stat	(revision 09f10ea22a97a54f71079faae7206def58b37826)
+++ Tst/Short/factorizeQ_s.stat	(revision 107aac1a78fd9b689a33a864d23b7cfb1caa5bdf)
@@ -1,4 +1,4 @@
-1 >> tst_memory_0 :: 1343902751:3150:3-1-5:ix86-Linux:mamawutz:173840
-1 >> tst_memory_1 :: 1343902751:3150:3-1-5:ix86-Linux:mamawutz:2240284
-1 >> tst_memory_2 :: 1343902751:3150:3-1-5:ix86-Linux:mamawutz:2273068
-1 >> tst_timer_1 :: 1343902751:3150:3-1-5:ix86-Linux:mamawutz:3
+1 >> tst_memory_0 :: 1346942495:3150:3-1-5:ix86-Linux:mamawutz:1005280
+1 >> tst_memory_1 :: 1346942495:3150:3-1-5:ix86-Linux:mamawutz:2240284
+1 >> tst_memory_2 :: 1346942495:3150:3-1-5:ix86-Linux:mamawutz:2273068
+1 >> tst_timer_1 :: 1346942495:3150:3-1-5:ix86-Linux:mamawutz:188
Index: Tst/Short/factorizeQ_s.tst
===================================================================
--- Tst/Short/factorizeQ_s.tst	(revision 09f10ea22a97a54f71079faae7206def58b37826)
+++ Tst/Short/factorizeQ_s.tst	(revision 107aac1a78fd9b689a33a864d23b7cfb1caa5bdf)
@@ -19,3 +19,9 @@
 testfactors (l,f);
 
+//tr. 448
+ring r = (0, ah, bh, sh0), (ch2, ch1, sh1, ch0), lp;
+poly p= ((bh^4)*ch0^4+(11232*ah^2*bh^2*sh0^2-11232*ah^2*bh^2-24960*ah*bh^3*sh0^2+24960*ah*bh^3+12168*bh^4*sh0^2-13736*bh^4)*ch0^2+(51609856*ah^4*sh0^4-103219712*ah^4*sh0^2+51609856*ah^4-179312640*ah^3*bh*sh0^4+358625280*ah^3*bh*sh0^2-179312640*ah^3*bh+243165312*ah^2*bh^2*sh0^4-475066112*ah^2*bh^2*sh0^2+231900800*ah^2*bh^2-151856640*ah*bh^3*sh0^4+284144640*ah*bh^3*sh0^2-132288000*ah*bh^3+37015056*bh^4*sh0^4-64490400*bh^4*sh0^2+28090000*bh^4))*((bh^4)*ch0^4+(11232*ah^2*bh^2*sh0^2-11232*ah^2*bh^2+24960*ah*bh^3*sh0^2-24960*ah*bh^3+12168*bh^4*sh0^2-13736*bh^4)*ch0^2+(51609856*ah^4*sh0^4-103219712*ah^4*sh0^2+51609856*ah^4+179312640*ah^3*bh*sh0^4-358625280*ah^3*bh*sh0^2+179312640*ah^3*bh+243165312*ah^2*bh^2*sh0^4-475066112*ah^2*bh^2*sh0^2+231900800*ah^2*bh^2+151856640*ah*bh^3*sh0^4-284144640*ah*bh^3*sh0^2+132288000*ah*bh^3+37015056*bh^4*sh0^4-64490400*bh^4*sh0^2+28090000*bh^4))*((bh^4)*ch0^4+(11232*ah^2*bh^2*sh0^2-11232*ah^2*bh^2-24320*ah*bh^3*sh0^2+24320*ah*bh^3+11552*bh^4*sh0^2-13120*bh^4)*ch0^2+(51609856*ah^4*sh0^4-103219712*ah^4*sh0^2+51609856*ah^4-174714880*ah^3*bh*sh0^4+349429760*ah^3*bh*sh0^2-174714880*ah^3*bh+230855168*ah^2*bh^2*sh0^4-450445824*ah^2*bh^2*sh0^2+219590656*ah^2*bh^2-140472320*ah*bh^3*sh0^4+261877760*ah*bh^3*sh0^2-121405440*ah*bh^3+33362176*bh^4*sh0^4-57667584*bh^4*sh0^2+24920064*bh^4));
+list l= factorize (p);
+testfactors (l,p);
+
 tst_status(1);$