Index: Tst/Short/paramet.res.gz.uu
===================================================================
--- Tst/Short/paramet.res.gz.uu	(revision 3551b68be48d70b29f4192882b1c1070a8a68c97)
+++ Tst/Short/paramet.res.gz.uu	(revision 110e7076324048d844c3281f451b3c6b4cb44c6c)
@@ -1,45 +1,45 @@
 begin 640 paramet.res.gz
-M'XL(".K_7#<``W!A<F%M970N<F5S`.U:6V_;-A1^SZ]@@SXXMI6(-UU<-`_#
-M"BQ`40SK@#T42Z'82F+`L0Q+;B4]]+?O4++((UJ*'3?--FQ!$%$B><3O7#X>
-M'N7C[S]??2"$T$MR<4%>7\TF9!6MHX<X.\_2;/R%T'-*:!@&%R[\^H32B0PF
-MG)'D)IK>/T1+\BY?D=<G'[=RV#G1;7ZN9.I;4=TBZ<1Q2'J?K#.2Q7!WFZS6
-MNGLQO]$3I9JH[[QS\O[J)W(*`M2HTS>ZQ[\D\/#S?#G/!F=O3M257-;/TBS*
-M-NEYLLGTZ&`[^FZ9K./!Z='03^%5@,O(FCR#&L/+&B12QVGUFN&0K.-9?`O@
-MEG=D'2UGR</["+0W'#:3J7NIE4ZITMT%2(\>5HLX!25K':_G9:S'(;M1WII#
-MJ.X0:)!$;3#)NEK.6W<\R,?%V7BVTF:A8);Y+(X69/XVOV9.<<U-'Q@!K68P
-M!UU^HG].3D`%GZ'Q-N5UDT&3G<"EZJ(GGWC3:B2%!C1SVP"8[J!FT8Q9BQZ7
-M];)WE8QTRS@"`UA8"7\,'B9V\>S(^_6W-D8G9=DH,T#A?I2Q^I8#;@V;[<)F
-M$L'VVK"Y[O`1[.`HV*&!#8AS5FC(W#T"<JK!8J#98T@Y-4@Y:R,5NH,;I%P<
-M@Y3+?J3>"R'U$=*@C53JCM`@%>XQ2`5MN[+Q8L&.`(H<^%#G%=P`%:(-U-,=
-MB&B$332'`44$5(!)RW%MV''.G:(TJ#NX:"]JYB.&"F@J-'(F>"H?8RR!&$M:
-MC.43IUER2I9)1E;K^8,F:XEH3-HT=H!")"8QX]^R@[Q:8/-"XW$U'E=/1U0D
-M+2H*`$^1;,A=G)$(O23*YLF2)+<DNX_5:C?3>%8O34M"W"5M[CH$:XB]7&/U
-MCF$MU^Q%CQG60TSE64P5@B*^KA,0GJQGL0*C1R+J\JI@L*`N4K/Z*B/J#EZO
-M4KV-K>E$VO0"U$9LXKNHC3S-KZ%\_X\6B!#[XO$\9373(Q$?^):;46*Z_&.H
-MP@\P5912T01L\2/X(YS2<THYR@4\+-D8=%[R45&*$8PQ+.*'E^UU=[O6!_72
-MG:>SSJ>KSJ??+P&Y=W/5NQ;+G)K0C<<W-XK5F5-S?!,%%;^K>Z[OJ0X16[C;
-M*]>U9-)=F;QGP=Q)L5C76B[=*WEKOP`ESP'MR2,#E"T'_!A'"P1*,R`IAL1X
-M6(P+U1H:9PKD"SD3'%N>Y!_-MF?O?.W-;Z\Q>QRDWY+[':31G(?,Z/?DQ0%B
-MP"`\QHRAB_CB6@ZU*:\],"2<=.`)'^5P+:[%L(0^`2VFQL%33XV`JYK'H<\?
-M%L,2G,!#<GR'#>M9O)JE[M0\H)WK8#MN0-VSH=G'0_JOH:"7]]R6;]4D1DQ6
-M?BREM;DR:\5"NE]J#ZD]4Y2)`VC8?6S%O5$6,A-E(>\YDX6H:A#*HZ+,PU'6
-MCHZ\CBP=9;**,HZB3&ZC3&RCS-M&68#DA%64;:-T&V5JGJRBM!X7X!#S_P^Q
-MEPXQT1++GR?$TI;4M"W53G%>-K8"%%NA506`4\3=_`NDR;N'J:_W\^E]<VQ,
-M-_,LNH$953J]2+*LBJTX2I-ENI5.79/P4Y?N!.AXLS]$J<O0,<LI-V,X:)<;
-M?=ZB+C\H8)[L:LB]6.->C:I1GSC$1YJEBDNC#FE5)4#QR3(FT^1A!==E1NXC
-MI6G;"GJ^AU1[S(F$NNA$HDXCP&2\*$=5X3$O.>@9^*Y$BG[^\\>+,HB=X;F6
-MF=P?DC7VT</W'%6V!D'5>&I5XZLR3[L:\$H/-4<,6A?D=WS'%`0H%79!H%V8
-MIE1:58&M8S3=R$^IC]H!:H?/<OYOQ#'$.FS/5XK4U$DH0XIA/5\J*!-HD)US
-MU)I[-.J8*O4FBX+<VI\L*&MO_6II@UO0I)*2Q>27#^]4/4N1Q,TZ6@(5WR:;
-MY0R\XMNW;_"Z=+/()JI04?<.XO0,6'HZC=/T=K.`-RIJV63Q3(VWRF^FTI@S
-MO1RS35`6=I]7*4>ZYC;#'Z`.SI`Z^`C4X?!A;O(ARGFW4G:D@GJJHE>?F@Y3
-M'SM0??7K_XC6ZMV3[72U-\9Y-,W(9D6RI`X]$#E?DH*\>O*<'.:TS:2M1"]X
-M;CY:59WU(VU&K3^TYW#9?5RE'`4IMS>30ZP8:"L6P]JM`V/!\(D6?)*_'VJP
-M'D6Z;27F?D<@",2S@G:?1:A`Y"'LPLT!*A1"J]#)X8@O1PRV8Z9*@*!.H;4I
-MY`^.!Z3]+GWS?U"`%/T!XN0.O6!VC)C^?+3MYK@;Q8^.#>$AZ_O=W\RH0+N9
-ML.L]!UA?NH8&O4(X>5",<@D-Y03@#7X![B`+KO(T;U0$HUS4-U([AJ0O[1A/
-MBE/YG_&;YN2VRS1RWY8K3=6#2KY[0*@SNN7FX0:@@,Z_1.NY.H3I`Y=$V8D\
-MIB)")<I/=I,]V9.B--IT]4"4/,BP+S>MEF=]KJ(>2BF\CI1B'P*/M1"8Q7M/
->327^IL3+$_@_BP;T[,WK$]KQ[T9_`:$OMR!A)0``
+M'XL("/F^@#<``W!A<F%M970N<F5S`.U:6V_;-A1^SZ]@@SXXMI6(-UU2-`_#
+M"JS`4`SK@#T42Z'$2B+`L0Q+[B0]]+?O4++((UJ*'3?U-FQ!$%$B><3O7#X>
+M'N7C;S^^_T`(H5?DXH*\?C^[),MH%3W&^7F>Y=,OA)Y30L,PN'#AUR>47LK@
+MDC.2WD2W#X_1@KPKEN3UR<>-''9.=)N?*YGZ5M2W2#IQ')(]I*N<Y#'<W:7+
+ME>Z>)S=ZHE03]9UW3GY^_P,Y!0%JU.D;W>-?$7CX.5DD^>CLS8FZDJOF699'
+M^3H[3]>Y'AUL1M\OTE4\.CT8^BF\"G`969<OH,;PJ@&)U&&`4O=*:Y52I9P+
+MF!X]+N=Q!EK42EPE5:S'(<-0WIE#J.X0:)!$;=#Y*EG<D]5;=SHJIN79=+8T
+MRP&])[,XFI/D;7'-G/*:FS[0,EK-*`%E?:)_7)X`QL_0>)OQILF@R4[@4G?1
+MDT^\;;620@.:N5T`3'=0LVC&K$5/JV;9,'$\)JMX%M^!BZ@!<*]G<00&L+`*
+M_A@\3&SCV9+WRZ]=C$[&\DEN@,+])&?-+0?<&C;;ALTD@NUU87/=X2/8P4&P
+M0P,;$!>LU)"Y>P#D3(/%0/.GD')JD'+612IT!S=(N3@$*9?#2+TC(?41TJ"+
+M5.J.T"`5[B%(!>VZLO%BP0X`BAQX7^<5W``5H@O4TQV(:(1--/L!1014@DFK
+M:6/8:<&=LC*H>[AH)VKF(X8*:"8T<B9X)I]B+($82UJ,Y1.G77)&%FE.EJOD
+M49.U1#0F;1K;0R$2DYCQ;]E#7AVP1:GQN!J/JZ<C*I(6%06`ITS7Y#[.281>
+M$N5)NB#I'<D?8K7:]6T\:Y:F)2'NDC9W[8,UQ%ZNL7J'L)9K]J*G#.LAIO(L
+MI@I!$7^N4A">KF:Q`J-'(NKRZF"PH,XSL_HZY>D/7J]6O8VM[43:]`+41FSB
+MNZB-/,UOH'S[CQ:($/OBZ3QE.=,C$1_XEIM18KK\0ZC"#S!55%+1!&SQ$_@C
+MG,IS*CDI!#RLV!1T7O%)68D)C#$LXH=7W77WN]8']=*MI[/>I\O>I]\N`;EW
+M>]6[%LN=AM"-Q[<WBM69TW!\&P4UOZM[KN^I#A%;N#LHU[5DTFV9?&#!W,FP
+M6-=:+MTI>6._`"7/`1W((P.4+0?\$$<+!$HS("F&Q'A<3DO5&AMG"N21G`G.
+M)<_RCW;;LW>^[N:WTY@##C)LR=T.TFK.0V;T!_+B`#%@$!YBQM!%?'$MQ]J4
+MUQX8$DXZ\(1/"KB6UV)<09^`%E/CX*FG1L!5S>/0YX_+<05.X"$YOL/&S2Q>
+MSU)W:A[0SG6P&3>B[MG8[.,A_==0T/$]M^-;#8D1DY4?2FE=KLP[L9#MECI`
+M:B\496(/&G:?6O%@E(7,1%G(!\YD(:H:A/*@*/-PE'6CHV@B2T>9K*.,HRB3
+MFR@3FRCS-E$6(#EA'66;*-U$F9HGZRAMQ@4XQ/S_0^S8(28Z8OG+A%C6D9IU
+MI=HISG%C*T"Q%5I5`#A%W"=?($W>/DS]^9#</K3'QFR=Y-$-S*C3Z7F:YW5L
+MQ5&6+K*-=.J:A)^Z="M`I^O=(4I=AHY93K6>PD&[6NOS%G7Y7@'S;%=#[L5:
+M]VI5C?K$/C[2+E5<&75(JRH!BD\7,;E-'Y=P7>3D(5*:MJV@YWM(M8><2*B+
+M3B3J-`),QLMJ4A<>BXJ#GH'O*J3HES]_')5![`S/M<SD?I>L<8@>ON6HLC$(
+MJL93JQI?EWFZU8!7>J@Y8M"F(+_E.Z8@0*FP"P+=PC2ETJH*;!RC[49^2GW4
+M#E`[?)'S?RN.(=9A.[Y29*9.0AE2#!OX4D&90(/LG*/1W)-1QU2I-YV7Y,[^
+M9$%9=^M72QO=@2:5E#PF/WUXI^I9BB1N5M$"J/@N72]FX!5?OWZ%UV7K>7ZI
+M"A5-[RC.SH"E;V_C++M;S^&-BEK6>3Q3XZWRFZDT%DPOQVP3E(7]YU7*D:ZY
+MS?![J(,SI`X^`74X?%R8?(ARWJ^4+:F@GKKH-:2F_=3']E1?\_K?HY5Z]^5F
+MNMH;XR*ZS<EZ2?*T"3T0F2Q(25X]>TX!<[IFTE:B%[PP'ZWJSN:1-J/6']IS
+MN.P_KE*.@I3;F\D^5@RT%<MQX]:!L6#X3`L^R]_W-=B`(MVN$@N_)Q`$XEE!
+M^\\B5"#R$';A9@\5"J%5Z!1PQ)<3!MLQ4R5`4*?0VA3R.\<#TGZ?OOD_*$#*
+MX0!Q"H=>,#M&3'\QV71SW(WB1\>&\)#U_?YO9E2@W4S8]9X]K"]=0X->*9PB
+M*">%A(9R`O`&OP1WD"57>9HW*8-)(9H;J1U#TF,[QK/B5/YG_*8]N6TSC=RU
+MY4I3]:"2;Q\0FHQNL7Z\`2B@\R_1*E&','W@DB@[D8=41*A$^<EVLB<'4I16
+MFZX>B)('&0[EIO7RK,]5U$,IA=>34NQ"X+$.`K-X[[FIQ-^4>'D"_^O0B)Z]
+0>7U">_Z?Z"_SW?0&0B4`````
 `
 end
Index: Tst/Short/paramet.stat
===================================================================
--- Tst/Short/paramet.stat	(revision 3551b68be48d70b29f4192882b1c1070a8a68c97)
+++ Tst/Short/paramet.stat	(revision 110e7076324048d844c3281f451b3c6b4cb44c6c)
@@ -3,9 +3,9 @@
 init >> HOSTNAME:nepomuck.mathematik.uni-kl.de
 init >> uname -a:Linux nepomuck.mathematik.uni-kl.de 2.0.33 #1 Wed Jan 21 18:50:57 MET 1998 i686 unknown
-init >> date    :Tue Jun  8 13:34:44 MET DST 1999
+init >> date    :Mon Jul  5 16:19:28 MET DST 1999
 init >> version :1303
 init >> ticks   :100
-1 >> tst_memory_0 :: nepomuck.mathematik.uni-kl.de:575836
-1 >> tst_memory_1 :: nepomuck.mathematik.uni-kl.de:700028
+1 >> tst_memory_0 :: nepomuck.mathematik.uni-kl.de:577356
+1 >> tst_memory_1 :: nepomuck.mathematik.uni-kl.de:700060
 1 >> tst_memory_2 :: nepomuck.mathematik.uni-kl.de:860160
-1 >> tst_timer_1 :: nepomuck.mathematik.uni-kl.de:870
+1 >> tst_timer_1 :: nepomuck.mathematik.uni-kl.de:929
Index: Tst/Short/primitiv_s.res.gz.uu
===================================================================
--- Tst/Short/primitiv_s.res.gz.uu	(revision 3551b68be48d70b29f4192882b1c1070a8a68c97)
+++ Tst/Short/primitiv_s.res.gz.uu	(revision 110e7076324048d844c3281f451b3c6b4cb44c6c)
@@ -1,35 +1,35 @@
 begin 640 primitiv_s.res.gz
-M'XL("`[=%#<``W!R:6UI=&EV7W,N<F5S`,U76V_;-A1^]Z]@C#U(H^CP)HJ*
-M80.[9$"![`)W#P.*-I!MI9$J6ZXD9[:&_?<=4C:E-&F*`7VH'D2*Y_`[]T/J
-M]9\_O_H-(<3FZ/(2_9(5Z17:5=DF:[*'VWK2U,WH]8F%3PS+Z_NR:E"3UDV-
-M[LK*,:,B6SI6,4$WKWY$8]@^@?7QU%'D','B;;;-&L^?CLR(YMU:W23-OIZ4
-M^UYD..]PSD(^`5-6:3)XK&*HO'-J@3GDZ>,0H@FJLNU[5,UH<`C6NQY;SWL,
-M+UNG2>$=.&8^*'W[AKV=F0^8<9BY/?$<?<B*`E4.AM%Y+\`[!$=_*(2!URTT
-MR@"/\.#(B>BI_$S-9P-5_)Y!S-%=LFK**FM3+P>M@`;OJQ'H8I5DW0R4/$K"
-MZ-'H#%^6@07,`<FSEFSFT2#QP1?%0$T(PR;9H=U]-JN`E/04B$#=V*WUK)MX
-MP.7E?J?,F2V:H_20KO9-ZHTWV797%L?9&-=X/!T/N/39WH>9`PE.,_[VG7'0
-MZ4N8KX&GP/$/T]&#,9G"P+M!F.'$PB$0V1WR:N.J!W].?4=A$_#&/VA\O5C\
-MOKBXN$"+M-X7C[,(W(ZR&FW+!B7]*DJ+=)-NFXOQ%/WK\+C-RK2H4W2RU4O\
-M&<0?O;]E,#5`]<=]4J5565HQW)#XLR3A8(4MOZ1&4#'U?;DOUFB9.JJ<H#KM
-M(M%G'X?`V<P2)K,._;IZE-SGE(8<$5U*'SF,X+ZCVQ$]26VN76H+F]I!^RBY
-M>3Q,;LR"HR!'PH*6XV-+F.,3]%EE6L9QRRAI8]Q&I`UQ*W#+R:GF2*MP*TDK
-M2-O5H3!KC%I>((7$L@-!`I0BK>SV8Y#L!+,G-@G^^8Y2[XK,.OC%CB+$Y$G!
-MUST^%)K#@7Y"PF"\8(,:$!"Q!?@&E$!H=9]44-YIE=5-MD)7B';K#.V`L$F!
-M`E^PGJ".<$HW='JND)>`"+\C;O>;)6P`2QZ2J@8B[];MLRS*U0<+?87*:IU:
-M$];U@*-_KM`6A-=F>D!']`P*'Z+\Y&R#K"O`%%3,'OD@`A_P,70=:_8V_=O8
-MD6T@<8PQVW*3)078*`E7,H%HBYA+APEY64"ZO./34>@6(3,7_"LZ\9'H;\:=
-M\3"73&L/QE_VHB9,L%@E"BL:ATQ3!=8Q)G5,>:PBH'`<A5IJ*2GGFE/F3A1/
-M*789*:6D8D)Q+9E*(B)D3`5LO!1:""ZHTDQRJFD28O@*895K'7VZ3Q`64Y#!
-M%5=4A)H]V>[ZLZ1?.9K_WP7?2LBEZUC!@@7&*6<"=[W8XY2*(/<#+PF6P2I8
-M/VK*$JX,YP,XAP.U)\AGBG,I\)+C)9R[IDL%AGY&!0DO9UJN,,]#PF.6P[$2
-MRUS@,&(@D\5ACIET!YN$EE?T]Y;$75"6(^CJ=K8:01NWL_7H37C*QAAP0L)T
-MG$L<"@7X3%'`C\,XQZ'L\P?:3A<YKX#-OFD5W!&CX17*V?OY>]02>T09PR!M
-M0;".<D$B`7(QERPG.N9^QRLL;QRJ/,1*4W`"#\$)1&L!2D84G"`B?6*6';`&
-M-X4DB@"8*8,L8H,LE02+&#3RP=TM&-S?I#X%[V80O!6$-S<MH0L;QWD2Y(%U
-MP1<B!R>OS.$LU2+.-=:@MB(ZBHT)PD10JSYXT(1N!L'C8`6C%+C\[_M(NC47
-M42^.*(B`2HQ`!-BJL*0FD)R#P8/HA5#]-_:^-XA:>*X#J(+^\`Y?.+RK9+LN
-M-S=)W3QW>CL$.+S30[+9%>E@AW76KBI7@S5T5Y4;\\N#AK\FH^N_?OCUCYMK
-M:Z*M1U2A&:+N>F0NU4`Z78N`U"-ZC/H=$?Z*[`\&#.8J!H.YW(@#CH^X'3E=
-6Y?"OR6/^]+L1>^97ZC\^FU-,X0T`````
+M'XL("-&^@#<``W!R:6UI=&EV7W,N<F5S`,U76V_;-A1^]Z]@C#U(H^CP)HJ*
+M80.[9$"![`)W#P.*-I!MI9$J6ZXD9[:&_?<=4C:E-&F*`7VH'RSJG,/OW`^I
+MUW_^_.HWA!";H\M+]$M6I%=H5V6;K,D>;NM)4S>CUR<1/C$BK^_+JD%-6C<U
+MNBLK)XR*;.E$Q03=O/H1C6'[!.CCJ>/(.0+B;;;-&L^?CLP3S3M:W23-OIZ4
+M^UYE..]PSDH^`5/6:#+X6<-0>>?,`G?(TY]#B":HRK;O436CP2%8[WIL/>\Q
+MO&R=)H5WX)CY8/3M&_9V9EY@Q6'E]L1S]"$K"E0Y&$;GO0+O$!S]H1(&4;?0
+M*`,\PH,C)Z+G\C,WGPU,\7L!,4=WR:HIJZQ-O1RL`A[\7XW`%FLDZU9@Y%$2
+M1H_&9GBS`BQ@#DB>K60SCP:)#[$H!F9"&C;)#NWNLUD%K*3G0`;JQFZM9]W"
+M`RDO]SMCSF+1'*6'=+5O4F^\R;:[LCC.QKC&X^EX(*7/_C[,'$AP6O&W[TR`
+M3F_"O`TB!8%_F(X>C,L4'KQ["/,XB7!(1':'O-J$ZL&?4]]QV`2B\0\:7R\6
+MOR\N+B[0(JWWQ>,J@K"CK$;;LD%)3T5ID6[2;7,QGJ)_'1ZW59D6=8I.OGJ)
+M/X/\H_>W#)8&J/ZX3ZJT*DNKAAL6?Y8E'*RP[9?4"#JFOB_WQ1HM4\>5$U2G
+M72;ZZN.0.%M9PE36H:>K1\5]+FFH$=&5])'#$\)W=#NB)Z7-M2MM84L[:!\5
+M-X^'Q8U9<!3D2%C0<GQL"7-R@CYK3,LX;ADE;8S;B+0A;@5N.3GU'&D5;B5I
+M!6F[/A2&QJB5!59(K#@P)$`ITLIN/P;-3C%[XI/@GY\H]:[(;(!?G"A"3)XT
+M?-WC0Z,Y')@G)`S&"S;H`0$96T!LP`B$5O=)!>V=5EG=9"MTA6A'9V@'C$T*
+M''@#>H(ZQJG<T.EWA;P$5/@=<[O?+&$#>/*05#4P>4>WOV51KCY8Z"M45NO4
+MNK"N!Q+][PIM07EME@=T1,^@\"'*3\XWJ+H"7$'%[%$,(H@!'\/4L6YOT[^-
+M']D&"L<XLRTW65*`CY)P)1/(MHBY=)A0EP64RSL^'86.")6YX%\QB(]4?S/A
+MC(>U9$9[,/YR%#5A@L4J45C1.&2:*O".,:ECRF,5`8?C*-122TDYUYPR=Z)X
+M2K'+2"DE%1.*:\E4$A$A8RI@XZ700G!!E6:24TV3$,-;"%2N=?3I/D%83$$'
+M5UQ1$6KV9+N;SY)^Y6S^_Q!\*RF7;F(%"Q:8H)P9W,UBCU,J@MP/O"18!JM@
+M_6@H2[@RG`_@'`[4GB&?:<ZEP$N.EW#NFBD5&/X9%32\7&FYPCP/"8]9#L=*
+M+'.!PXB!3A:'.6;2'6P21E[1WUL2=T%9CF"JV]5J!&/<KM:C-^&I&F/`"0G3
+M<2YQ*!3@,T4!/P[C'(>RKQ\8.UWFO`(V^V94<,>,AE<HY^_G[U%+[!%E'(.R
+M!<4ZR@6)!.C%7+*<Z)C[G:RPLG&H\A`K32$(/(0@$*T%&!E1"(*(]$E8=L`:
+MPA22*`)@I@RRB`VR5!(\8C#(!W>W8'!_D_J4O)M!\E:0WMR,A"YM'.=)D`<V
+M!%_(')R\,H>S5(LXUUB#V8KH*#8N")-!K?KDP1"Z&22/@Q>,4I#RO^\SZ6@N
+MHUX<45`!G1B!"O!584E-(CD'AP?9"Z'[;^Q];Y"U\-P'T`7]X1V^<'A7R79=
+M;FZ2NGGN]'8(<'BGAV2S*]+!#ANL756N!C1T5Y4;\\ESHID/D]'U7S_\^L?-
+MM770=B.JT`Q1=SDR5VI@G2Y%P.KQ/$;]C@G?1/;S`A[F(@8/<[41!QP?<3MR
+7ELKA-Y/'_.EW(_;,A]1_9]ICI-\-````
 `
 end
Index: Tst/Short/primitiv_s.stat
===================================================================
--- Tst/Short/primitiv_s.stat	(revision 3551b68be48d70b29f4192882b1c1070a8a68c97)
+++ Tst/Short/primitiv_s.stat	(revision 110e7076324048d844c3281f451b3c6b4cb44c6c)
@@ -3,9 +3,9 @@
 init >> HOSTNAME:nepomuck.mathematik.uni-kl.de
 init >> uname -a:Linux nepomuck.mathematik.uni-kl.de 2.0.33 #1 Wed Jan 21 18:50:57 MET 1998 i686 unknown
-init >> date    :Wed Apr 14 20:23:05 MET DST 1999
-init >> version :1302
+init >> date    :Mon Jul  5 16:18:41 MET DST 1999
+init >> version :1303
 init >> ticks   :100
-1 >> tst_memory_0 :: nepomuck.mathematik.uni-kl.de:139463
+1 >> tst_memory_0 :: nepomuck.mathematik.uni-kl.de:141547
 1 >> tst_memory_1 :: nepomuck.mathematik.uni-kl.de:215891
-1 >> tst_memory_2 :: nepomuck.mathematik.uni-kl.de:196608
-1 >> tst_timer_1 :: nepomuck.mathematik.uni-kl.de:80
+1 >> tst_memory_2 :: nepomuck.mathematik.uni-kl.de:159744
+1 >> tst_timer_1 :: nepomuck.mathematik.uni-kl.de:657